import java.applet.Applet;
import java.util.Enumeration;
import java.util.Vector;

public abstract class Talker
	extends Applet
	{
	/*
	Talkers on the same webpage can communicate.
	*/

	private Vector talkers = null;

	public void initializeTalkers()
		{
		/*
		Find all other Talkers on this talker's webpage.
		*/

		if (talkers == null)
			talkers = new Vector();

		Enumeration applets = this.getAppletContext().getApplets();
		while (applets.hasMoreElements())
			{
			Applet applet = (Applet) applets.nextElement();
			if ((applet instanceof Talker) && (applet != this))
				talkers.addElement(applet);
			}
		}

	public void broadcast(Message message)
		{
		/*
		Send a message to all Talkers on the same page.
		*/

		if (talkers == null)
			initializeTalkers();

		Enumeration e = talkers.elements();
		while (e.hasMoreElements())
			((Talker) e.nextElement()).take(message);
		}

	public abstract void take(Message message);
	}
